routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Auth::routes(['register' => false]);
Route::group(['middleware' => 'admin'], function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('/company','CompanyController');
    Route::get('/companyDatatable','CompanyDatatable')->name('companyDatatable');
    Route::resource('/employee','EmployeeController');
    Route::get('/employeeDatatable','EmployeeDatatable')->name('employeeDatatable');
});

app/Company.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Company extends Model
{
    protected $fillable = ['name'];
    protected $table = 'companies';

    public function employee(){
        return $this->hasMany(Employee::class);
    }

    public function images()
    {
        return $this->morphOne(Image::class ,'imageable', 'model_type', 'model_id');
    }
}

app/Http/Controllers/Api/v1/CompanyController.php
<?php

namespace App\Http\Controllers\Api\v1;

use App\Company;
use App\Http\Controllers\Controller;
use App\Http\Requests\CompanyRequest;
use App\Http\Resources\CompanyResources;
use App\Image;
use Illuminate\Http\Request;

class CompanyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        try{
            $page = ($request->has("page") ?$request->page : 1)  ;
            $company = Company::paginate(5, ['*'], 'page', $page);
            return CompanyResources::collection($company);

        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while show all companies '
            ]);

        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CompanyRequest $request)
    {
        try{
            //create Main Company Data
            $company = new Company(['name' => $request->name]);
            $company->save();

            //upload company image
            $imageName = time().'.'.request()->image->getClientOriginalExtension();
            request()->image->move(public_path('images'), $imageName);

            // add image to company model
            $imageable = new Image();
            $imageable->image_path = $imageName;
            $imageable->model_id = $company->id;
            $imageable->model_type = 'App\Company';
            $company->images()->save($imageable);
            return new CompanyResources(Company::find($company->id));
        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while Create company'
            ]);

        }


    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        try{
            return new CompanyResources(Company::find($id));
        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while show company'
            ]);
        }


    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try{
            $request->validate([
                'image' => 'image|mimes:jpeg,png,jpg',
                'name' =>'required'
            ]);
            $company =  Company::findOrFail($id);
            if($request->has('name')){
                $company->name =$request->name;
            }
            if($request->hasfile('image')){
                //upload company image
                $imageName = time().'.'.request()->image->getClientOriginalExtension();
                request()->image->move(public_path('images'), $imageName);

                // add image to company model
                Image::where(['model_id'=>$id,'model_type'=>'App\Company'])
                    ->update(['image_path'=>$imageName]);
            }
            $company->save();
            return new CompanyResources(Company::find($id));

        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while update company'.$e
            ]);

        }


    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try{
            Company::destroy($id);
            return response()->json([
                'message' => 'Successfully deleted Company!'
            ]);

        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while delete company'
            ]);

        }

    }
}

app/Http/Controllers/CompanyController.php
<?php

namespace App\Http\Controllers;

use App\Company;
use App\Http\Requests\CompanyRequest;
use App\Image;
use Illuminate\Http\Request;

class CompanyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('company.datatable');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('company.create');

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CompanyRequest $request)
    {
        //create Main Company Data
        $company = new Company(['name' => $request->name]);
        $company->save();

        //upload company image
        $imageName = time().'.'.request()->image->getClientOriginalExtension();
        request()->image->move(public_path('images'), $imageName);

        // add image to company model
        $imageable = new Image();
        $imageable->image_path = $imageName;
        $imageable->model_id = $company->id;
        $imageable->model_type = 'App\Company';
        $company->images()->save($imageable);
        return redirect()->route('company.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $company = Company::with('images')->findOrFail($id);
        return view('company.edit',compact('company'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'image' => 'image|mimes:jpeg,png,jpg|max:2048',
            'name' =>'required'
        ]);
        $company =  Company::findOrFail($id);
        $company->name =$request->name;
        $company->save();

        if($request->hasfile('image')){
            //upload company image
            $imageName = time().'.'.request()->image->getClientOriginalExtension();
            request()->image->move(public_path('images'), $imageName);

            // add image to company model
            Image::where(['model_id'=>$id,'model_type'=>'App\Company'])
                ->update(['image_path'=>$imageName]);
        }
        return redirect()->route('company.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Company::destroy($id);
        return redirect()->route('company.index');
    }
}

resources/views/company/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Create Company</h3>
                            </div>
                        </div>
                    </div>
                    <br>
                    @if (count($errors) > 0)

                        <div class="alert alert-danger">

                            <strong>Whoops!</strong> There were some problems with your input.

                            <ul>

                                @foreach ($errors->all() as $error)

                                    <li>{{ $error }}</li>

                                @endforeach

                            </ul>

                        </div>

                    @endif

                    <div class="panel-body">
                        <form action="{{route('company.store')}}" method="post" enctype="multipart/form-data">
                            {{csrf_field()}}
                            <div class="form-group">
                                <label for="exampleInput1">Company Name</label>
                                <input type="text" name="name" class="form-control" id="exampleInput1"  placeholder="Enter Company Name" required>
                            </div>
                            <div class="form-group">
                                <label for="exampleFormControlFile1">Image file input</label>
                                <input type="file" name="image" class="form-control-file" id="exampleFormControlFile1" required>
                            </div>
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/company/datatable.blade.php
@extends('layouts.app')
@section('style')
    <link href="https://cdn.datatables.net/1.10.12/css/jquery.dataTables.min.css" rel="stylesheet">
@endsection
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Company Datatable</h3>
                            </div>
                            <div class="col-md-4">
                                <a href="{{route('company.create')}}" class="btn btn-dark" >Create Company</a>
                            </div>
                        </div>
                     </div>
                    <br>


                    <div class="panel-body">
                        <table class="table table-hover table-bordered table-striped datatable" style="width:100%">
                            <thead>
                            <tr>
                                <th>Id</th>
                                <th>Name</th>
                                <th>image</th>
                                <th>action</th>
                            </tr>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>
        </div>    </div>
@endsection
@section('script')
    <script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $.noConflict();
            console.log('test')
            $('.datatable').DataTable({
                processing: true,
                serverSide: true,
                ajax: '{{ route('companyDatatable') }}',
                columns: [
                    {data: 'id', name: 'id'},
                    {data: 'name', name: 'name'},
                    {data: 'images', name: 'images',orderable: false, searchable:false },
                    {data: 'action', name: 'action',orderable: false, searchable:false },
                ]
            });
        });
    </script>
@endsection

resources/views/company/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Edit Company</h3>
                            </div>
                        </div>
                    </div>
                    <br>
                    @if (count($errors) > 0)

                        <div class="alert alert-danger">

                            <strong>Whoops!</strong> There were some problems with your input.

                            <ul>

                                @foreach ($errors->all() as $error)

                                    <li>{{ $error }}</li>

                                @endforeach

                            </ul>

                        </div>

                    @endif

                    <div class="panel-body">
                        <form action="{{route('company.update',[$company->id])}}" method="post" enctype="multipart/form-data">
                            {{ method_field('PATCH') }}
                            {{csrf_field()}}
                            <div class="form-group">
                                <label for="exampleInput1">Company Name</label>
                                <input type="text" name="name" class="form-control" id="exampleInput1"  placeholder="Enter Company Name" value="{{$company->name}}" required>
                            </div>
                            <div class="form-group">
                                <label for="exampleFormControlFile1">Image file input</label>
                                <input type="file" name="image" value="" class="form-control-file" id="exampleFormControlFile1">
                                <img src="{{asset('/images/'.$company->images->image_path)}}" alt="" width="150" height="150">
                            </div>
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection